/**********************************************************************
 *
 * Filename:    stdint.h
 * 
 * Description: Standard header file to declare sets of integer types
 *              that have specified widths.
 *
 * Notes:       
 *
 * 
 * Copyright (c) 2006 Anthony Massa and Michael Barr. All rights reserved.
 * This code is from the book Programming Embedded Systems, With C and
 * GNU Development Tools, 2nd Edition.
 * It is provided AS-IS, WITHOUT ANY WARRANTY either expressed or implied.
 * You may study, use, and modify it for any non-commercial purpose,
 * including teaching and use in open-source projects.
 * You may distribute it non-commercially as long as you retain this notice.
 * For a commercial use license, or to purchase the book,
 * please visit http://www.oreilly.com/catalog/embsys2.
 *
 **********************************************************************/

#ifndef _STDINT_H
#define _STDINT_H


typedef signed char    int8_t;
typedef unsigned char  uint8_t;

typedef short          int16_t;
typedef unsigned short uint16_t;

typedef int            int32_t;
typedef unsigned int   uint32_t;


#endif /* _STDINT_H */
